LeetCode 486. Predict the Winner

原題連接在這裏:https://leetcode.com/problems/predict-the-winner/description/html

題目:java

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.post

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.優化

Example 1:url

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. 
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2).
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5.
Hence, player 1 will never be the winner and you need to return False.

Example 2:spa

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:code

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

題解:htm

dp[i][j]是nums 從i到j這一段[i, j] 先手的player 比 後手多獲得多少分.blog

先手 pick first. 遞推時 dp[i][j] = Math.max(nums[i]-dp[i+1][j], nums[j]-dp[i][j-1]). 若是A選了index i的score, B只能選擇[i+1, j]區間內的score. 若是A選了index j的score, B只能選擇[i, j-1]區間內的score.ip

看到計算dp[i][j]時, i 須要 i+1, j 須要 j-1. 因此循環時 i從大到小, j 從小到大.

初始化區間內只有一個數字時就是能獲得的最大分數.

答案看[0, nums.length-1]區間內 A獲得的score是否大於等於0.

Time Complexity: O(len^2). len = nums.length.

Space: O(len^2).

AC Java:

 1 class Solution {
 2     public boolean PredictTheWinner(int[] nums) {
 3         if(nums == null || nums.length == 0){
 4             return true;
 5         }
 6         
 7         int len = nums.length;
 8         int [][] dp = new int[len][len];
 9         for(int i = len-1; i>=0; i--){
10             for(int j = i+1; j<len; j++){
11                 int head = nums[i]-dp[i+1][j];
12                 int tail = nums[j]-dp[i][j-1];
13                 dp[i][j] = Math.max(head, tail);
14             }
15         }
16         return dp[0][len-1] >= 0;
17     }
18 }

空間優化.

Time Complexity: O(len^2). len = nums.length.

Space: O(len).

AC Java:

 1 class Solution {
 2     public boolean PredictTheWinner(int[] nums) {
 3         if(nums == null || nums.length == 0){
 4             return true;
 5         }
 6         
 7         int len = nums.length;
 8         int [] dp = new int[len];
 9         for(int i = len-1; i>=0; i--){
10             for(int j = i+1; j<len; j++){
11                 int head = nums[i]-dp[j];
12                 int tail = nums[j]-dp[j-1];
13                 dp[j] = Math.max(head, tail);
14             }
15         }
16         return dp[len-1] >= 0;
17     }
18 }

另外一種implementation.

Time Complexity: O(len^2). len = nums.length.

Space: O(len^2).

 1 class Solution {
 2     public boolean PredictTheWinner(int[] nums) {
 3         if(nums == null || nums.length == 0){
 4             return true;
 5         }
 6         
 7         int n = nums.length;
 8         int [][] dp = new int[n][n];
 9         for(int i = 0; i<n; i++){
10             dp[i][i] = nums[i];
11         }
12         
13         for(int size = 1; size<n; size++){
14             for(int i = 0; i+size<n; i++){
15                 dp[i][i+size] = Math.max(nums[i]-dp[i+1][i+size], nums[i+size]-dp[i][i+size-1]);
16             }
17         }
18         
19         return dp[0][n-1] >= 0;
20     }
21 }

Exact the same as Stone Game.

Reference: https://discuss.leetcode.com/topic/76830/java-9-lines-dp-solution-easy-to-understand-with-improvement-to-o-n-space-complexity 

相關文章
相關標籤/搜索